# frozen_string_literal: true

require "core/pipeline/compiler"

require_relative "result"

module Core
  module Operation
    class Compiler < Pipeline::Compiler
      class << self
        private def compile_call(callable, object)
          code = +"result = Core::Operation::Result.new\n"
          code += "object.localize(:result, result) do\n"
          code += super
          code += "end\n"
          code += "result.finalize\n"
          code
        end

        private def compile_action(action, object)
          "result.set(#{action[:object].name.inspect}, #{super})\n"
        end
      end
    end
  end
end
