# frozen_string_literal: true

module Core
  module Operation
    class Result
      def initialize
        @values = {}
        @latest = nil
      end

      def finalize
        @values.freeze
        freeze
        self
      end

      def value
        @latest
      end

      def set(name, value)
        @values[name.to_sym] = value
        @latest = value
      end

      def get(name)
        @values[name.to_sym]
      end

      def to_hash
        @values.dup
      end
    end
  end
end
