# frozen_string_literal: true

require "is/extension"
require "is/localized"
require "is/pipeline"

require_relative "../core/operation/compiler"
require_relative "../core/operation/result"

module Is
  # [public]
  #
  module Operation
    extend Is::Extension

    applies do
      pipeline.compiler = Core::Operation::Compiler
    end

    extends dependencies: [Is::Localized, Is::Pipeline]

    extends :definition, :implementation do
      # [public]
      #
      def action(*args, curry: true, **kwargs, &block)
        super(*args, curry: curry, **kwargs)
      end
    end

    extends :implementation do
      # [public]
      #
      def get(name)
        localized(:result).get(name)
      end

      # [public]
      #
      def set(name, value)
        localized(:result).set(name, value)
      end
    end
  end
end
